# Features
The table was designed to be *extremely flexible and light*; it doesn't make any assumptions about your data or 
how you: filter, sort or page it. That said, we wanted to keep the features strictly related to dealing 
with the data rather than implementing complex filtering/etc that is often very use-case specific. 
The current features include:

- Handle large data sets ( Virtual DOM )
- Expressive Header and Cell Templates
- Horizontal & Vertical Scrolling
- Column Reordering & Resizing
- Client/Serve side Pagination & Sorting
- Intelligent Column Width Algorithms ( Force-fill & Flex-grow )
- Integrated Pager
- Cell Selection
- Row Selection ( Single & Multi )
- Fixed AND Fluid height
- Left and Right Column Pinning
- Row Detail View
- Decoupled theme'ing with included Google Material theme
- Light codebase / No external dependencies

### Roadmap
We are really excited about the table and wanted to get it out into the open as quickly as 
possible so we had to delay some of the features but we plan to add the following:

- Better RxJS Support
- Touch selection support
- Checkbox Selection
- Tree Grids
- Row Grouping

### Alternatives
This might not be the best fit for you given the above, there are some other great solutions 
and some this project borrows from; heres a short list:

- [ng2-super-table](https://github.com/andyperlitch/ng2-super-table)
- [ng2-table](https://github.com/valor-software/ng2-table)
- [vaadin-grid](https://github.com/vaadin/vaadin-grid)
- [iron-data-table](https://github.com/Saulis/iron-data-table/)
- [paper-datatable](https://github.com/David-Mulder/paper-datatable)
